"""
Copyright (C) Cross The Road Electronics.  All rights reserved.
License information can be found in CTRE_LICENSE.txt
For support and suggestions contact support@ctr-electronics.com or file
an issue tracker at https://github.com/CrossTheRoadElec/Phoenix-Releases
"""

from enum import Enum

class SpnValue(Enum):
    TALON_FX_SYSTEM_STATE = 612
    STARTUP_RESET_FLAGS = 633
    VERSION_MAJOR = 731
    VERSION_MINOR = 732
    VERSION_BUGFIX = 733
    VERSION_BUILD = 734
    VERSION_FULL = 735
    LICENSING_IS_PRO_LICENSED = 748
    LICENSING_IS_SEASON_PASSED = 751
    CUSTOM_PARAM0 = 816
    CUSTOM_PARAM1 = 817
    CANCODER_SENSOR_DIRECTION = 821
    FRC_LOCK = 823
    ROBOT_ENABLED = 824
    LED1_ON_COLOR = 826
    LED1_OFF_COLOR = 827
    LED2_ON_COLOR = 828
    LED2_OFF_COLOR = 829
    ALL_FAULTS = 835
    ALL_STICKY_FAULTS = 836
    PIGEON2_USE_COMPASS = 910
    PIGEON2_DISABLE_TEMPERATURE_COMPENSATION = 945
    PIGEON2_DISABLE_NO_MOTION_CALIBRATION = 947
    PIGEON2_MOUNT_POSE_YAW = 952
    PIGEON2_MOUNT_POSE_PITCH = 953
    PIGEON2_MOUNT_POSE_ROLL = 954
    PIGEON2_GYRO_SCALARX = 958
    PIGEON2_GYRO_SCALARY = 959
    PIGEON2_GYRO_SCALARZ = 960
    PIGEON2_YAW = 967
    PIGEON2_PITCH = 968
    PIGEON2_ROLL = 969
    PIGEON2_QUATW = 970
    PIGEON2_QUATX = 971
    PIGEON2_QUATY = 972
    PIGEON2_QUATZ = 973
    PIGEON2_GRAVITY_VECTORX = 974
    PIGEON2_GRAVITY_VECTORY = 975
    PIGEON2_GRAVITY_VECTORZ = 976
    PIGEON2_TEMPERATURE = 977
    PIGEON2_NO_MOTION_CAL_ENABLED = 978
    PIGEON2_NO_MOTION_COUNT = 979
    PIGEON2_TEMP_COMP_DISABLED = 980
    PIGEON2_UP_TIME = 981
    PIGEON2_ACCUM_GYROX = 982
    PIGEON2_ACCUM_GYROY = 983
    PIGEON2_ACCUM_GYROZ = 984
    PIGEON2_ANGULAR_VELOCITYX = 985
    PIGEON2_ANGULAR_VELOCITYY = 986
    PIGEON2_ANGULAR_VELOCITYZ = 987
    PIGEON2_ACCELERATIONX = 988
    PIGEON2_ACCELERATIONY = 989
    PIGEON2_ACCELERATIONZ = 990
    PIGEON2_SUPPLY_VOLTAGE = 991
    PIGEON2_MAGNETIC_FIELDX = 996
    PIGEON2_MAGNETIC_FIELDY = 997
    PIGEON2_MAGNETIC_FIELDZ = 998
    PIGEON2_RAW_MAGNETIC_FIELDX = 999
    PIGEON2_RAW_MAGNETIC_FIELDY = 1000
    PIGEON2_RAW_MAGNETIC_FIELDZ = 1001
    CANCODER_MAGNET_OFFSET = 1002
    CANCODER_ABSOLUTE_SENSOR_RANGE = 1003
    TALON_FX_SET_SENSOR_POSITION = 1007
    CANCODER_SET_SENSOR_POSITION = 1009
    PIGEON2_SET_YAW = 1011
    DEVICE_ENABLED = 1040
    PRO_MOTOR_OUTPUT_MOTOR_VOLTAGE = 2019
    FORWARD_LIMIT = 2020
    REVERSE_LIMIT = 2021
    PRO_MOTOR_OUTPUT_ROTOR_POLARITY = 2022
    PRO_MOTOR_OUTPUT_DUTY_CYCLE = 2023
    PRO_MOTOR_OUTPUT_TORQUE_CURRENT = 2025
    PRO_SUPPLY_AND_TEMP_STATOR_CURRENT = 2026
    PRO_SUPPLY_AND_TEMP_SUPPLY_CURRENT = 2027
    PRO_SUPPLY_AND_TEMP_SUPPLY_VOLTAGE = 2028
    PRO_SUPPLY_AND_TEMP_DEVICE_TEMP = 2029
    PRO_SUPPLY_AND_TEMP_PROCESSOR_TEMP = 2030
    PRO_ROTOR_POS_AND_VEL_VELOCITY = 2032
    PRO_ROTOR_POS_AND_VEL_POSITION = 2033
    PRO_POS_AND_VEL_VELOCITY = 2036
    PRO_POS_AND_VEL_POSITION = 2037
    PRO_POS_AND_VEL_ACCELERATION = 2038
    PRO_PIDSTATE_ENABLES_INTEGRATED_ACCUM_DC = 2040
    PRO_PIDSTATE_ENABLES_INTEGRATED_ACCUM_V = 2041
    PRO_PIDSTATE_ENABLES_INTEGRATED_ACCUM_A = 2042
    PRO_PIDSTATE_ENABLES_FEED_FORWARD_DC = 2043
    PRO_PIDSTATE_ENABLES_FEED_FORWARD_V = 2044
    PRO_PIDSTATE_ENABLES_FEED_FORWARD_A = 2045
    TALON_FX_CONTROL_MODE = 2046
    PRO_PIDSTATE_ENABLES_IS_MOTION_MAGIC_RUNNING = 2047
    PRO_PIDSTATE_ENABLES_DEVICE_ENABLE = 2049
    PRO_PIDREF_PIDERR_PIDREF_POSITION = 2051
    PRO_PIDREF_PIDERR_PIDREF_VELOCITY = 2052
    PRO_PIDREF_PIDERR_PIDERR_POSITION = 2053
    PRO_PIDREF_PIDERR_PIDERR_VELOCITY = 2054
    PRO_PIDOUTPUT_PROPORTIONAL_OUTPUT_DC = 2056
    PRO_PIDOUTPUT_PROPORTIONAL_OUTPUT_V = 2057
    PRO_PIDOUTPUT_PROPORTIONAL_OUTPUT_A = 2058
    PRO_PIDOUTPUT_DERIVATIVE_OUTPUT_DC = 2059
    PRO_PIDOUTPUT_DERIVATIVE_OUTPUT_V = 2060
    PRO_PIDOUTPUT_DERIVATIVE_OUTPUT_A = 2061
    PRO_PIDOUTPUT_OUTPUT_DC = 2062
    PRO_PIDOUTPUT_OUTPUT_V = 2063
    PRO_PIDOUTPUT_OUTPUT_A = 2064
    PRO_PIDOUTPUT_SLOT = 2065
    PRO_PIDREF_SLOPE_ECUTIME_REFERENCE_SLOPE_POSITION = 2066
    PRO_PIDREF_SLOPE_ECUTIME_REFERENCE_SLOPE_VELOCITY = 2067
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_DUTY_CYCLE = 2070
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_TORQUE_CURRENT = 2071
    TALON_FX_DIFFERENTIAL_CONTROL_MODE = 2074
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_INTEGRATED_ACCUM_DC = 2075
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_INTEGRATED_ACCUM_V = 2076
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_INTEGRATED_ACCUM_A = 2077
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_FEED_FORWARD_DC = 2078
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_FEED_FORWARD_V = 2079
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_FEED_FORWARD_A = 2080
    PRO_AVG_POS_AND_VEL_VELOCITY = 2082
    PRO_AVG_POS_AND_VEL_POSITION = 2083
    PRO_DIFF_POS_AND_VEL_VELOCITY = 2086
    PRO_DIFF_POS_AND_VEL_POSITION = 2087
    PRO_DIFF_PIDREF_PIDERR_PIDREF_POSITION = 2089
    PRO_DIFF_PIDREF_PIDERR_PIDREF_VELOCITY = 2090
    PRO_DIFF_PIDREF_PIDERR_PIDERR_POSITION = 2091
    PRO_DIFF_PIDREF_PIDERR_PIDERR_VELOCITY = 2092
    PRO_DIFF_PIDOUTPUT_PROPORTIONAL_OUTPUT_DC = 2094
    PRO_DIFF_PIDOUTPUT_PROPORTIONAL_OUTPUT_V = 2095
    PRO_DIFF_PIDOUTPUT_PROPORTIONAL_OUTPUT_A = 2096
    PRO_DIFF_PIDOUTPUT_DERIVATIVE_OUTPUT_DC = 2097
    PRO_DIFF_PIDOUTPUT_DERIVATIVE_OUTPUT_V = 2098
    PRO_DIFF_PIDOUTPUT_DERIVATIVE_OUTPUT_A = 2099
    PRO_DIFF_PIDOUTPUT_OUTPUT_DC = 2100
    PRO_DIFF_PIDOUTPUT_OUTPUT_V = 2101
    PRO_DIFF_PIDOUTPUT_OUTPUT_A = 2102
    PRO_DIFF_PIDOUTPUT_SLOT = 2103
    PRO_DIFF_PIDREF_SLOPE_ECUTIME_REFERENCE_SLOPE_POSITION = 2104
    PRO_DIFF_PIDREF_SLOPE_ECUTIME_REFERENCE_SLOPE_VELOCITY = 2105
    SLOT0_KP = 2107
    SLOT0_KI = 2108
    SLOT0_KD = 2109
    SLOT0_KS = 2110
    SLOT0_KV = 2111
    SLOT0_KA = 2112
    SLOT0_KG = 2113
    SLOT0_KG_TYPE = 2114
    SLOT1_KP = 2115
    SLOT1_KI = 2116
    SLOT1_KD = 2117
    SLOT1_KS = 2118
    SLOT1_KV = 2119
    SLOT1_KA = 2120
    SLOT1_KG = 2121
    SLOT1_KG_TYPE = 2122
    SLOT2_KP = 2123
    SLOT2_KI = 2124
    SLOT2_KD = 2125
    SLOT2_KS = 2126
    SLOT2_KV = 2127
    SLOT2_KA = 2128
    SLOT2_KG = 2129
    SLOT2_KG_TYPE = 2130
    CONFIG_INVERTED = 2131
    CONFIG_SUPPLY_VLOWPASS_TAU = 2132
    CONFIG_BEEP_ON_BOOT = 2133
    CONFIG_NEUTRAL_MODE = 2134
    CONFIG_DUTY_CYCLE_NEUTRAL_DB = 2135
    CONFIG_STATOR_CURRENT_LIMIT = 2136
    CONFIG_STATOR_CURR_LIMIT_EN = 2137
    CONFIG_SUPPLY_CURRENT_LIMIT = 2138
    CONFIG_SUPPLY_CURR_LIMIT_EN = 2139
    CONFIG_PEAK_FORWARD_DC = 2140
    CONFIG_PEAK_REVERSE_DC = 2141
    CONFIG_PEAK_FORWARDV = 2142
    CONFIG_PEAK_REVERSEV = 2143
    CONFIG_PEAK_FOR_TORQ_CURR = 2144
    CONFIG_PEAK_REV_TORQ_CURR = 2145
    CONFIG_TORQUE_NEUTRAL_DB = 2146
    CONFIG_FEEDBACK_ROTOR_OFFSET = 2147
    CONFIG_SENSOR_TO_MECHANISM_RATIO = 2148
    CONFIG_ROTOR_TO_SENSOR_RATIO = 2149
    CONFIG_FEEDBACK_SENSOR_SOURCE = 2150
    CONFIG_FEEDBACK_REMOTE_SENSOR_ID = 2151
    CONFIG_DUTY_CYCLE_OPEN_LOOP_RAMP_PERIOD = 2152
    CONFIG_VOLTAGE_OPEN_LOOP_RAMP_PERIOD = 2153
    CONFIG_TORQUE_OPEN_LOOP_RAMP_PERIOD = 2154
    CONFIG_DUTY_CYCLE_CLOSED_LOOP_RAMP_PERIOD = 2155
    CONFIG_VOLTAGE_CLOSED_LOOP_RAMP_PERIOD = 2156
    CONFIG_TORQUE_CLOSED_LOOP_RAMP_PERIOD = 2157
    CONFIG_FORWARD_LIMIT_TYPE = 2158
    CONFIG_FORWARD_LIMIT_AUTOSET_POS_ENABLE = 2159
    CONFIG_FORWARD_LIMIT_AUTOSET_POS_VALUE = 2160
    CONFIG_FORWARD_LIMIT_ENABLE = 2161
    CONFIG_FORWARD_LIMIT_SOURCE = 2162
    CONFIG_FORWARD_LIMIT_REMOTE_SENSOR_ID = 2163
    CONFIG_REVERSE_LIMIT_TYPE = 2164
    CONFIG_REVERSE_LIMIT_AUTOSET_POS_ENABLE = 2165
    CONFIG_REVERSE_LIMIT_AUTOSET_POS_VALUE = 2166
    CONFIG_REVERSE_LIMIT_ENABLE = 2167
    CONFIG_REVERSE_LIMIT_SOURCE = 2168
    CONFIG_REVERSE_LIMIT_REMOTE_SENSOR_ID = 2169
    CONFIG_FORWARD_SOFT_LIMIT_ENABLE = 2170
    CONFIG_REVERSE_SOFT_LIMIT_ENABLE = 2171
    CONFIG_FORWARD_SOFT_LIMIT_THRESHOLD = 2172
    CONFIG_REVERSE_SOFT_LIMIT_THRESHOLD = 2173
    CONFIG_MOTION_MAGIC_CRUISE_VELOCITY = 2174
    CONFIG_MOTION_MAGIC_ACCELERATION = 2175
    CONFIG_MOTION_MAGIC_JERK = 2176
    CONFIG_PEAK_DIFF_DC = 2177
    CONFIG_PEAK_DIFFV = 2178
    CONFIG_PEAK_DIFF_TORQ_CURR = 2179
    CANCODER_VELOCITY = 2180
    CANCODER_POSITION = 2181
    CANCODER_ABS_POSITION = 2182
    CANCODER_RAW_VEL = 2184
    CANCODER_RAW_POS = 2185
    CANCODER_SUPPLY_VOLTAGE = 2186
    CANCODER_MAG_HEALTH = 2187
    SPN_CLEAR_STICKY_FAULTS = 2190
    PRO_MOTOR_OUTPUT_BRIDGE_TYPE_PUBLIC = 2191
    CONFIG_CONTINUOUS_WRAP = 2213
    CONFIG_SUPPLY_CURR_THRES = 2219
    CONFIG_SUPPLY_TIME_THRES = 2220
    CONFIG_DIFFERENTIAL_SENSOR_SOURCE = 2234
    CONFIG_DIFFERENTIAL_TALON_FXSENSOR_ID = 2235
    CONFIG_DIFFERENTIAL_REMOTE_SENSOR_ID = 2236
    CONFIG_BEEP_ON_CONFIG = 2275
    CONFIG_ALLOW_MUSIC_DUR_DISABLE = 2276
    COMPLIANCY_VERSION = 2277
    VERSION_IS_PRO_LICENSED = 2278
    PRO_SUPPLY_AND_TEMP_DEVICE_TEMP2 = 2317
    FAULT_HARDWARE = 10001
    STICKY_FAULT_HARDWARE = 10002
    CLEAR_STICKY_FAULT_HARDWARE = 10003
    FAULT_PROC_TEMP = 10004
    STICKY_FAULT_PROC_TEMP = 10005
    CLEAR_STICKY_FAULT_PROC_TEMP = 10006
    FAULT_DEVICE_TEMP = 10007
    STICKY_FAULT_DEVICE_TEMP = 10008
    CLEAR_STICKY_FAULT_DEVICE_TEMP = 10009
    FAULT_UNDERVOLTAGE = 10010
    STICKY_FAULT_UNDERVOLTAGE = 10011
    CLEAR_STICKY_FAULT_UNDERVOLTAGE = 10012
    FAULT_BOOT_DURING_ENABLE = 10013
    STICKY_FAULT_BOOT_DURING_ENABLE = 10014
    CLEAR_STICKY_FAULT_BOOT_DURING_ENABLE = 10015
    FAULT_UNLICENSED_FEATURE_IN_USE = 10016
    STICKY_FAULT_UNLICENSED_FEATURE_IN_USE = 10017
    FAULT_PIGEON2_BOOTUP_ACCEL = 10019
    STICKY_FAULT_PIGEON2_BOOTUP_ACCEL = 10020
    CLEAR_STICKY_FAULT_PIGEON2_BOOTUP_ACCEL = 10021
    FAULT_PIGEON2_BOOTUP_GYROS = 10022
    STICKY_FAULT_PIGEON2_BOOTUP_GYROS = 10023
    CLEAR_STICKY_FAULT_PIGEON2_BOOTUP_GYROS = 10024
    FAULT_PIGEON2_BOOTUP_MAGNE = 10025
    STICKY_FAULT_PIGEON2_BOOTUP_MAGNE = 10026
    CLEAR_STICKY_FAULT_PIGEON2_BOOTUP_MAGNE = 10027
    FAULT_PIGEON2_BOOT_INTO_MOTION = 10028
    STICKY_FAULT_PIGEON2_BOOT_INTO_MOTION = 10029
    CLEAR_STICKY_FAULT_PIGEON2_BOOT_INTO_MOTION = 10030
    FAULT_PIGEON2_DATA_ACQUIRED_LATE = 10031
    STICKY_FAULT_PIGEON2_DATA_ACQUIRED_LATE = 10032
    CLEAR_STICKY_FAULT_PIGEON2_DATA_ACQUIRED_LATE = 10033
    FAULT_PIGEON2_LOOP_TIME_SLOW = 10034
    STICKY_FAULT_PIGEON2_LOOP_TIME_SLOW = 10035
    CLEAR_STICKY_FAULT_PIGEON2_LOOP_TIME_SLOW = 10036
    FAULT_PIGEON2_SATURATED_MAGNE = 10037
    STICKY_FAULT_PIGEON2_SATURATED_MAGNE = 10038
    CLEAR_STICKY_FAULT_PIGEON2_SATURATED_MAGNE = 10039
    FAULT_PIGEON2_SATURATED_ACCEL = 10040
    STICKY_FAULT_PIGEON2_SATURATED_ACCEL = 10041
    CLEAR_STICKY_FAULT_PIGEON2_SATURATED_ACCEL = 10042
    FAULT_PIGEON2_SATURATED_GYROS = 10043
    STICKY_FAULT_PIGEON2_SATURATED_GYROS = 10044
    CLEAR_STICKY_FAULT_PIGEON2_SATURATED_GYROS = 10045
    FAULT_CANCODER_BAD_MAGNET = 10046
    STICKY_FAULT_CANCODER_BAD_MAGNET = 10047
    CLEAR_STICKY_FAULT_CANCODER_BAD_MAGNET = 10048
    FAULT_TALONFX_BRIDGE_BROWNOUT = 10049
    STICKY_FAULT_TALONFX_BRIDGE_BROWNOUT = 10050
    CLEAR_STICKY_FAULT_TALONFX_BRIDGE_BROWNOUT = 10051
    FAULT_TALONFX_REMOTE_SENSOR_RESET = 10052
    STICKY_FAULT_TALONFX_REMOTE_SENSOR_RESET = 10053
    CLEAR_STICKY_FAULT_TALONFX_REMOTE_SENSOR_RESET = 10054
    FAULT_TALONFX_MISSING_DIFFERENTIAL_FX = 10055
    STICKY_FAULT_TALONFX_MISSING_DIFFERENTIAL_FX = 10056
    CLEAR_STICKY_FAULT_TALONFX_MISSING_DIFFERENTIAL_FX = 10057
    FAULT_TALONFX_REMOTE_SENSOR_POS_OVERFLOW = 10058
    STICKY_FAULT_TALONFX_REMOTE_SENSOR_POS_OVERFLOW = 10059
    CLEAR_STICKY_FAULT_TALONFX_REMOTE_SENSOR_POS_OVERFLOW = 10060
    FAULT_TALONFX_OVER_SUPPLYV = 10061
    STICKY_FAULT_TALONFX_OVER_SUPPLYV = 10062
    CLEAR_STICKY_FAULT_TALONFX_OVER_SUPPLYV = 10063
    FAULT_TALONFX_UNSTABLE_SUPPLYV = 10064
    STICKY_FAULT_TALONFX_UNSTABLE_SUPPLYV = 10065
    CLEAR_STICKY_FAULT_TALONFX_UNSTABLE_SUPPLYV = 10066
    FAULT_TALONFX_REVERSE_HARD_LIMIT = 10067
    STICKY_FAULT_TALONFX_REVERSE_HARD_LIMIT = 10068
    CLEAR_STICKY_FAULT_TALONFX_REVERSE_HARD_LIMIT = 10069
    FAULT_TALONFX_FORWARD_HARD_LIMIT = 10070
    STICKY_FAULT_TALONFX_FORWARD_HARD_LIMIT = 10071
    CLEAR_STICKY_FAULT_TALONFX_FORWARD_HARD_LIMIT = 10072
    FAULT_TALONFX_REVERSE_SOFT_LIMIT = 10073
    STICKY_FAULT_TALONFX_REVERSE_SOFT_LIMIT = 10074
    CLEAR_STICKY_FAULT_TALONFX_REVERSE_SOFT_LIMIT = 10075
    FAULT_TALONFX_FORWARD_SOFT_LIMIT = 10076
    STICKY_FAULT_TALONFX_FORWARD_SOFT_LIMIT = 10077
    CLEAR_STICKY_FAULT_TALONFX_FORWARD_SOFT_LIMIT = 10078
    FAULT_TALONFX_MISSING_REMOTE_SENSOR = 10085
    STICKY_FAULT_TALONFX_MISSING_REMOTE_SENSOR = 10086
    CLEAR_STICKY_FAULT_TALONFX_MISSING_REMOTE_SENSOR = 10087
    FAULT_TALONFX_FUSED_SENSOR_OUT_OF_SYNC = 10088
    STICKY_FAULT_TALONFX_FUSED_SENSOR_OUT_OF_SYNC = 10089
    CLEAR_STICKY_FAULT_TALONFX_FUSED_SENSOR_OUT_OF_SYNC = 10090
    FAULT_TALONFX_STATOR_CURR_LIMIT = 10091
    STICKY_FAULT_TALONFX_STATOR_CURR_LIMIT = 10092
    CLEAR_STICKY_FAULT_TALONFX_STATOR_CURR_LIMIT = 10093
    FAULT_TALONFX_SUPPLY_CURR_LIMIT = 10094
    STICKY_FAULT_TALONFX_SUPPLY_CURR_LIMIT = 10095
    CLEAR_STICKY_FAULT_TALONFX_SUPPLY_CURR_LIMIT = 10096
    FAULT_TALONFX_USING_FUSED_CCWHILE_UNLICENSED = 10097
    STICKY_FAULT_TALONFX_USING_FUSED_CCWHILE_UNLICENSED = 10098